#include <stdio.h>
#include "basava.h"
#include <limits.h>
#include <math.h>
/*
#include <apr.h>        
#include <apr_general.h> // For apr_initialize
#include <apr_strings.h>
#include <apr_file_io.h>
#include <apr_pools.h>
*/
#define BITS_IN_int     ( sizeof(int) * CHAR_BIT )
#define THREE_QUARTERS  ((int) ((BITS_IN_int * 3) / 4))
#define ONE_EIGHTH      ((int) (BITS_IN_int / 8))
#define HIGH_BITS       ( ~((unsigned int)(~0) >> ONE_EIGHTH ))
#define SYMTABLE_LENGTH 65536
#define HASHVALUES_LENGTH ( sizeof(unsigned int))
#define HASH_SCALE_FACTOR ( pow(2,(HASHVALUES_LENGTH * 8)) / SYMTABLE_LENGTH)

extern void yyerror(const char *);   /* prints grammar violation message */
extern int yylineno;     // Line no for debugging messages
extern char* yytext;

// apr_pool_t *local_pool;


unsigned int symbolTableAdd(const char* word);
unsigned int HashPJW ( const char * datum );

/*--- HashPJW ---------------------------------------------------
 *  An adaptation of Peter Weinberger's (PJW) generic hashing
 *  algorithm based on Allen Holub's version. Accepts a pointer
 *  to a datum to be hashed and returns an unsigned integer.
 *  Ref: http://www.drdobbs.com/database/hashing-rehashed/184409859
 *  Date Accessed: Nov 21, 2014
 *-------------------------------------------------------------*/

unsigned int HashPJW ( const char * datum )
{
    unsigned int hash_value, i;
    for ( hash_value = 0; *datum; ++datum )
    {
        hash_value = ( hash_value << ONE_EIGHTH ) + *datum;
        if (( i = hash_value & HIGH_BITS ) != 0 )
            hash_value =
                ( hash_value ^ ( i >> THREE_QUARTERS )) &
                        ~HIGH_BITS;
    }
    return ( hash_value );
}


unsigned int symbolTableAdd(const char* word) {
	unsigned int h = HashPJW(word);
	int scaled = (int) h / (HASH_SCALE_FACTOR==0?1:HASH_SCALE_FACTOR);
	printf("SymAdd --> %s, Hash --> %d, Scaled --> %d\n", word, h, scaled);
	return 0;
}
